<template>
  <v-alert
    v-if="warning"
    type="warning"
    border="start"
    variant="tonal"
    closable
    close-label="Close Alert"
    color="amber-darken-3"
    title="กรุณากรอกข้อมูลของท่านให้ครบถ้วน"
  />
  <v-alert
    v-if="confirmWarning"
    type="warning"
    border="start"
    variant="tonal"
    closable
    close-label="Close Alert"
    color="amber-darken-3"
    title="กรุณายืนยันที่อยู่อีเมลของท่านให้เรียบร้อย"
  />
  <v-alert
    v-if="errmsg"
    type="error"
    border="start"
    variant="tonal"
    closable
    close-label="Close Alert"
    color="red"
    title="ชื่อผู้ใช้หรือรหัสผ่านของท่านไม่ถูกต้อง"
  />
  <div v-if="loaded" class="d-flex justify-center align-center container">
    <v-card class="card" rounded="xl">
      <div class="position">
        <img src="/assets/image/Rmuti_Logo.png" />
      </div>

      <div class="position">
        <p>ระบบยืม-คืน</p>
      </div>

      <div class="position">
        <label>มหาวิทยาลัยเทคโนโลยีราชมงคลอีสาน วิทยาเขตขอนแก่น</label>
      </div>

      <v-text-field
        v-model="identifier"
        :readonly="loading"
        :rules="[IdentifierRules]"
        clearable
        class="mb-0"
        placeholder="Username or Email"
        density="comfortable"
        variant="solo"
        rounded="xl"
        type="text"
      ></v-text-field>

      <v-text-field
        v-model="password"
        @click:append-inner="visible = !visible"
        @keyup.enter="onLogin"
        :readonly="loading"
        :rules="[PasswordRules]"
        :type="visible ? 'text' : 'password'"
        :append-inner-icon="visible ? 'mdi-eye-off' : 'mdi-eye'"
        clearable
        class="mb-0"
        placeholder="Password"
        density="comfortable"
        variant="solo"
        rounded="xl"
      ></v-text-field>

      <div class="forgot-pass">
        <nuxt-link class="nuxt-link" to="/forgot-password"
          >ลืมรหัสผ่าน
        </nuxt-link>
      </div>

      <v-btn
        @click="onLogin"
        :loading="loading"
        block
        class="login-button"
        size="large"
        variant="flat"
        rounded="xl"
        >เข้าสู่ระบบ
      </v-btn>

      <v-btn
        @click="onGoogle"
        block
        class="google-button text-none justify-items-auto"
        color="#ffffff"
        size="large"
        variant="flat"
        rounded="xl"
        ><img src="../assets/image/google-icon.png" />Sign-in with Google
      </v-btn>

      <div class="position pt-3">
        ยังไม่มีบัญชีผู้ใช้ ?
        <a class="register-text" href="/register">สมัครสมาชิก</a>
      </div>
    </v-card>
  </div>
</template>

<script setup>
useHead({
  title: "ระบบยืม-คืน | เข้าสู่ระบบ",
  meta: [{ name: "description", content: "ระบบยืม-คืนอุปกรณ์สาขาวิชา" }],
});

definePageMeta({
  layout: false,
});
import { ref, onMounted } from "vue";

const { login, getProviderAuthenticationUrl } = useStrapiAuth();
const router = useRouter();

const identifier = ref(null)
const password = ref(null)
const loading = ref(false)
const loaded = ref(false)

const visible = ref(false)
const warning = ref(false)
const confirmWarning = ref(false)
const errmsg = ref(false)

const IdentifierRules = (v) => {
  return !!v || "กรุณากรอกชื่อผู้ใช้ หรือ อีเมล";
};
const PasswordRules = (v) => {
  return !!v || "กรุณากรอกรหัสผ่าน";
};

async function onLogin() {
  loading.value = true;
  setTimeout(() => (loading.value = false), 2000);

  if (!identifier.value || !password.value) {
    console.error("กรุณากรอกข้อมูลให้ครบ");
    warning.value = true;
    setTimeout(() => (warning.value = false), 3000);
  } else {
    try {
      await login({ identifier: identifier.value, password: password.value });

      router.push("/");
    } catch (error) {
      if (error.error.name === "ValidationError") {
        console.log(error.error);
        errmsg.value = true;
        setTimeout(() => (errmsg.value = false), 5000);
      } else if (
        error.error.message === "Your account email is not confirmed"
      ) {
        console.log(error.error);
        confirmWarning.value = true;
        await new Promise((resolve) => setTimeout(resolve, 3000));
        confirmWarning.value = false;
        router.push("/email-confirmation");
      }
    }
  }
}

const onGoogle = () => {
  window.location = getProviderAuthenticationUrl('google')
}

onMounted(async()=>{
  loaded.value = true
})
</script>

<style scoped>
@import url(../assets/css/styles/login.css);
</style>
